
int
get_hdr_row(
  char* buff,
  int i,
  int l,
  HANDLE log_h
  )
{
  int j;  // must be signed !!!
  ULONG read_bytes;

  for(j=0; i+j<l && j<sizeof(MailRowBuffer)-1; j++) {
    MailRowBuffer[j] = buff[i+j];
    if(MailRowBuffer[j] == '\n' ||
       MailRowBuffer[j] == '\r') {
      break;
    }
    if(MailRowBuffer[j] == 0) {
      sprintf(LogBuffer, "Achtung! 0 in hdr\n");
      printf(LogBuffer);
      if(log_h) {
          WriteFile(log_h, LogBuffer, strlen(LogBuffer), &read_bytes, NULL);
      }
      break;
    }
  }
  if(j == sizeof(MailRowBuffer)-1) {
    sprintf(LogBuffer, "LogBuffer, Achtung! too long hdr\n");
    if(log_h) {
        WriteFile(log_h, LogBuffer, strlen(LogBuffer), &read_bytes, NULL);
    } else {
        printf(LogBuffer);
    }
  }
  return j;
} // end get_hdr_row()

int
fetch_fragment(
    HANDLE in_h,
    HANDLE out_h,
    HANDLE log_h,
    char* buff,
    ULONG* i_buff_ptr,
    char* o_buff,
    ULONG* o_buff_ptr,
    ULONG xbs,
    ULONG* _r,
    __int64 f_ptr,
    __int64 *_o_ptr
    )
{
        int ok;
//        ULONG r/*, w*/;
        int i0, i, j, l, l0;  // must be signed !!!
        BOOLEAN restored = FALSE;
        ULONG len=0;
        ULONG stored_len;
        ULONG read_bytes;
        PTBB_MSG_HDR mhdr, prev_mhdr;
        __int64 lba = (__int64)(f_ptr/(unsigned __int64)bs);
//        __int64 lbao = (__int64)(o_ptr/(unsigned __int64)bs);

        fill_buffer(buff, xbs, fill_stringW, fill_stringA);
        ok = 0;

        set_file_pointer(in_h, f_ptr);
        //set_file_pointer(out_h, o_ptr);
        read_bytes = 0;
        if(!ReadFile(in_h, buff+iobs, xbs, &read_bytes, NULL) ||
            read_bytes != xbs) {
            read_bytes = GetLastError();
            //if(!r) {
                printf("Can't read block (%d bytes) at offset %I64d (LBA %I64d) error %d\n", xbs, f_ptr, lba, read_bytes);
            //}
            Sleep(1000);
            if(new_target && (fill_stringA || fill_stringW)) {
                goto set_filler;
            }
        } else {
            //if(r) {
            //    printf("Read on attempt #%d\n", r+1);
            //}
            ok = 1;
set_filler:
/*                for(w=0; w<3; w++) {
                WriteFile(out_h, buff, xbs, &read_bytes, NULL);
                if(read_bytes != xbs) {
                    read_bytes = GetLastError();
                    printf("Can't write block at offset %I64d (LBA %I64d) error %d\n", o_ptr, lbao, read_bytes);
                    if(read_bytes == 1450) {
                        // insufficient resources
                        set_file_pointer(out_h, o_ptr);
                        Sleep(1);
                        continue;
                    }
                    ok = ok ? -1 : -2;
                    break;
                }
                break;
            }*/
            //break;
            ;
        }

/*        if(ok<0) {
            if(log_h) {
                sprintf(LogBuffer, "output error at %I64d (LBA %I64d) size %d (%d blocks), error %d\n", *_o_ptr, lbao, xbs, xbs/bs, read_bytes);
                WriteFile(log_h, LogBuffer, strlen(LogBuffer), &read_bytes, NULL);
            }
        } else*/
        if(!ok) {
            //bads += xbs;
            if(log_h) {
                sprintf(LogBuffer, "bad at %I64d (LBA %I64d) size %d (%d blocks)\n", f_ptr, lba, xbs, xbs/bs);
                WriteFile(log_h, LogBuffer, strlen(LogBuffer), &read_bytes, NULL);
            }
        } else
        /*if(r)*/ {
            //susp += xbs;
            /*if(log_h) {
                sprintf(LogBuffer, "unreliable at %I64d (LBA %I64d) size %d (%d blocks)\n", f_ptr, lba, xbs, xbs/bs);
                WriteFile(log_h, LogBuffer, strlen(LogBuffer), &read_bytes, NULL);
            }*/

            i = *i_buff_ptr;
            if(!i) {
              i = iobs;
            }
/*            if(m_ptr) {
                i = iobs-TB_HDR_SZ-MAIL_HDR_SZ;
            } else {
              if(f_ptr) {
                i = iobs-TB_HDR_SZ-MAIL_HDR_SZ;
              } else {
                i = iobs;
              }
            }*/

            //(*_o_ptr + *o_buff_ptr) // last written byte

            l = iobs+read_bytes-TB_HDR_SZ-MAIL_HDR_SZ;
            l0 = iobs+read_bytes;

            for(i0=i; i<l; i++, len++) {
              mhdr = (PTBB_MSG_HDR)(buff+i);

              if(dump_from && o_writing && !from_printed) {
                if(mhdr->Signature[0] == 0x0d &&
                   mhdr->Signature[1] == 0x0a &&
                   !memcmp(&mhdr->Signature[2], "From: ", 6)) {
                  j = get_hdr_row(buff, i+2, l-2, log_h);
                  if(log_h) {
                    WriteFile(log_h, &mhdr->Signature[2], j+2, &read_bytes, NULL);
                  } else {
                    printf(MailRowBuffer);
                    printf("\n");
                  }
                  from_printed = 1;
                  continue;
                }
              }

              if(mhdr->Signature[0] != '!') {
                continue;
              }

              if(o_writing) {
                // copy previous part to output buffer
                stored_len = store_msg(buff+i0, len, FALSE);
                if(!stored_len) {
                  sprintf(LogBuffer, "Achtung! Can't allocate memory for %d bytes\n\n",
                    len);
                  if(log_h) {
                    WriteFile(log_h, LogBuffer, strlen(LogBuffer), &read_bytes, NULL);
                  } else {
                    printf(LogBuffer);
                  }
                }
                // flush header or message
                write_output(
                    out_h,
                    o_buff,
                    o_buff_ptr,
                    m_buff,
                    m_buff_ptr,
                    _o_ptr,
                    FALSE
                    );
                m_buff_ptr = 0;
              }
              i0=i;
              len=0;

              if(mhdr->Signature[1] == 0x09 &&
                 mhdr->Signature[2] == 0x70 &&
                 mhdr->Signature[3] == 0x19 &&
                 mhdr->HdrLength == TB_HDR_SZ &&
                 mhdr->tail0 == 0
                 ) {
                // found

                from_printed = 0;
                restored = 0;
                m_ptr = f_ptr-iobs+i;
                prev_mhdr = (PTBB_MSG_HDR)m_buff;

                if(next_m_ptr && (next_m_ptr != m_ptr)) {
                    sprintf(LogBuffer, "Achtung! broken MsgLength %d, should be %d\n\n",
                      prev_msg_len, (ULONG)(m_ptr-(next_m_ptr-prev_msg_len)) );
                    if(log_h) {
                      WriteFile(log_h, LogBuffer, strlen(LogBuffer), &read_bytes, NULL);
                    } else {
                      printf(LogBuffer);
                    }
                    if(!list_msg && !keep_msg) {
                        prev_mhdr->MsgLength = (ULONG)(m_ptr-(next_m_ptr-prev_msg_len));
                    }
                }
/*                if(o_writing && prev_mhdr->MsgLength+prev_mhdr->HdrLength != m_buff_ptr) {
                    printf("Check!\n");
                }*/

                // flush header or message
                write_output(
                    out_h,
                    o_buff,
                    o_buff_ptr,
                    m_buff,
                    m_buff_ptr,
                    _o_ptr,
                    FALSE
                    );
                m_buff_ptr = 0;

                next_m_ptr = m_ptr+mhdr->HdrLength+mhdr->MsgLength;
                prev_msg_len = mhdr->MsgLength;
                //printf("%32.32s\n", buff+i+TB_HDR_SZ);
                dm_count++;
                i += TB_HDR_SZ;
                len = TB_HDR_SZ;

                // extra validation
                // here we expect one ASCII row of email header
                j = get_hdr_row(buff, i, l0, log_h);

                if(skip_deleted) {
                  if(mhdr->Flags & MSG_FLAG_DEL) {
                    o_writing = FALSE;
                    len = 0;
                    continue;
                  }
                } else {
                  if(mhdr->Flags & MSG_FLAG_DEL) {
                    restored = 1;
                  }
                  mhdr->Flags &= ~MSG_FLAG_DEL;
                }

                if(skip_msg) {
                  skip_msg--;
                  o_writing = FALSE;
                  len = 0;
                  continue;
                }

                o_writing = TRUE;

                m_count++;
                if(lim_msg && m_count>lim_msg) {
                  break;
                }
                MailRowBuffer[j] = 0;
                sprintf(LogBuffer, "%s[%d] at %I64x: %s\n", (mhdr->Flags & MSG_FLAG_DEL) ? "del" : "msg", dm_count, m_ptr, MailRowBuffer);
                if(log_h) {
                    WriteFile(log_h, LogBuffer, strlen(LogBuffer), &read_bytes, NULL);
                } else {
                    printf(LogBuffer);
                }
                if(restored) {
                  sprintf(LogBuffer, "restored\n");
                  if(log_h) {
                    WriteFile(log_h, LogBuffer, strlen(LogBuffer), &read_bytes, NULL);
                  } else {
                    printf(LogBuffer);
                  }
                }
                if((prev_msg_len & 0x80000000)/* || (next_m_ptr > )*/) {
                  sprintf(LogBuffer, "Achtung! wrong message length %#x\n", prev_msg_len);
                  if(log_h) {
                      WriteFile(log_h, LogBuffer, strlen(LogBuffer), &read_bytes, NULL);
                  } else {
                      printf(LogBuffer);
                  }
                }
                //len++;
                //i--;
                len += j;
                i += j;
              }
            }

            if(xbs < bs) {
              // copy tail on last (unaligned) transaction
              len += l0-i;
              i = l0;
            }
            if(o_writing) {
              // we are inside message body, just copy to output buffer
              stored_len = store_msg(buff+i0, len, FALSE);
              if(!stored_len) {
                sprintf(LogBuffer, "Achtung! Can't allocate memory for %d bytes\n\n",
                  len);
                if(log_h) {
                  WriteFile(log_h, LogBuffer, strlen(LogBuffer), &read_bytes, NULL);
                } else {
                  printf(LogBuffer);
                }
                len = 0;
                i0=i;
              }
              if(!keep_msg) {
                // flush header or message, if we don't try to repair it
                write_output(
                    out_h,
                    o_buff,
                    o_buff_ptr,
                    m_buff,
                    m_buff_ptr,
                    _o_ptr,
                    FALSE
                    );
                m_buff_ptr = 0;
              }
            }
            if((xbs & (bs-1)) || !xbs) {
/*              if(m_buff_ptr) {
                prev_mhdr = (PTBB_MSG_HDR)m_buff;
                if(prev_mhdr->MsgLength+prev_mhdr->HdrLength != m_buff_ptr) {
                    printf("Check!\n");
                }
              }*/
              // flush message
              write_output(
                  out_h,
                  o_buff,
                  o_buff_ptr,
                  m_buff,
                  m_buff_ptr,
                  _o_ptr,
                  TRUE
                  );
              m_buff_ptr = 0;
            }
            *i_buff_ptr = i;
        }
        //f_ptr += xbs;
        //*copy_count += xbs;


    //*_r = r;
    return ok;
} // end fetch_fragment()
